/* TADS.C							*/
/* Contiene el manejador principal del sistema			*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "definic.h"
#include "declara.h"
#include "os_dep.h"
#include "interf.h"

/**************************************************************************
* main(int argc,char **argv)                                              *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* PROPOSITO:   Manejar el nivel superior de interaccion MANTA-usuario.    *
* DESCRIPCION: Despliega el menu principal de MANTA e invoca los modulos  *
*        de acuerdo a las selecciones del usuario hasta que este desee    *
*        desee terminar.                                                  *
*        -p : Presentacion                                                *
*        -i : Archivo de iniciacion                                       *
* PRE!:  { TRUE }                                                         *
* POST!: { Se ejecutaron las opciones del menu principal de MANTA de      *
*          acuedo a las selecciones del usuario.                       }  *
* LLAMA A: 								  *
*  void ini_term void			void ini_kbd_vt220		  *
*  *LINEA_PANT desp_presentacion   	int  lea_tecla			  *
*  void borr_presentacion		void cargue_tads_primitivos       * 
*  int  menu				void manejar_tipos                * 
*  void manejar_representaciones   	void manejar_teoremas             * 
*  void manejar_prototipos   		                                  *
*  void borre_pant			void fin_term			  *
*  void fin_kbd_vt220                					  *
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
* AUTOR: Carolina Ruiz Carrizosa                         FECHA: 25-Ene-90 *
* MODIFICADA: Hernan Aponte                                               *
* VTP. 20/Dic/96.  Antes invocaba una funcin para pedir nombre de usuario*
*      esto no es portable y se puso en compilacion condicional           *
*      Hacia llamadas al sistema para borrar archivo (rm) e invocar touch *
*      se reemplazaron por invocaciones a las funciones unlink y touch    *
**************************************************************************/
int
main(int argc,char **argv)
{/*----------------------------------------------------------------------*/

    int   opcion;
    cad20 inic;
    int   correcto;
    FILE  *fp;
    texpr merr;


    correcto=0;
    strcpy(inic,"");
    switch(argc) {
      case 1:
	strcpy(inic,"manta.ini");
	correcto=1;
	break;
      case 2:
	break;
      case 3:
	if (strcmp(argv[1],"-i")==0) {
	    strcpy(inic,argv[2]);
	    correcto=1;
        }
	break;
      case 4:
        break;
      default:
        break;
    }
    if (!correcto) {
        escriba_cadena("Invalid parameters",1); 
	return 1;
      }

    fp=fopen(inic,"r");
    if (fp==NULL) {
      escriba_cadena("Coldn't find configuration file",1);
      return 1;
      }

    fclose(fp);
    iniciar_editor_direct(inic);
    iniciar_mensajes();
    iniciar_claves();
    iniciar_menus();


    nombre_autor(nombre_usuario); /*** VTP. 20/Dic/96. ***/

    cargue_tads_primitivos();    
    symtable=NULL;
    if (loadSymbols(&symtable,merr)!=0)
      {
	printf("%s",merr);
	return -3;
      }

    if (!flag_emacs)
      desp_presentacion();

    opcion = admon_menu(menus_manta[MANTA]);
    while ( opcion != NO_OPCION &&
	    opcion != menus_manta[MANTA]->num_op - 2) {
      switch (opcion) {
      case 0:
	manejar_tipos();
	break;
      case 1:
	manejar_teoremas();
	break;
      case 2:
	manejar_prototipos();
	break;
      case 4:
	escriba_mensaje(151);   /* Mensaje de ayuda */
	break;
      default:
	escriba_mensaje(146);   /* Opcion Desconocida */
	break;       
      }
      opcion = admon_menu(menus_manta[MANTA]);
    } 

    salve_todo_tad();
    /*** VTP. Decia system("touch ./basura~; touch ./#basura"); ***/
    touch("./basura~");
    touch("./#basura");
    /*** VTP. Decia  system("rm -f ./ *~; rm -f ./#*"); sin
         el espacio entre / y el *. ***/
    if (symtable!=NULL)
      {
	freeSymbols(&symtable);
      }

    if (flag_emacs)
      printf("terminar\nfin-objeto");
    return 0;
/*----------------------------------------------------------------------*/}


